/*
 * Author:          Patrick-Christopher Mattulat
 * Co-Author:       Claude Sonnet 4.6 (LLM)
 * Company:         Lynar Studios
 * E-Mail:          webmaster@lynarstudios.com
 * Created:         2020-08-16
 * Changed:         2026-06-23
 *
 * */

#include <gtest/gtest.h>
#include <ls-std-core-test.hpp>
#include <ls-std/ls-std-core.hpp>

using ls::standard::core::Class;
using ls::standard::core::IllegalArgumentException;
using std::make_shared;
using std::shared_ptr;
using test::core::ClassWrapper;
using testing::Test;

namespace
{
  class ClassTest : public Test
  {
    public:

      ClassTest() = default;
      ~ClassTest() override = default;
  };

  TEST_F(ClassTest, constructor_empty_parameter)
  {
    EXPECT_THROW(
        {
          try
          {
            Class object{""};
          }
          catch (const IllegalArgumentException &_exception)
          {
            throw;
          }
        },
        IllegalArgumentException);
  }

  TEST_F(ClassTest, destructor)
  {
    const auto object = make_shared<ClassWrapper>();
    EXPECT_CALL(*object, Die());
  }

  TEST_F(ClassTest, getClassName)
  {
    const Class object{"Class"};
    ASSERT_STREQ("Class", object.getClassName().c_str());
  }

}
